function reporting_account (reporting){
    "use strict";

    var instance = openerp;

    reporting.ReportingAccountWidget = reporting.Base.extend({
        template: 'ReportingAccount',
        AccountVoucher: [],
        content:[],
        rowsData :[],
        moveLine: [],
        resCompany: [],
        resCurrecy: [],
        content: [],
        modelId: [],
        accountInvoice: [],

        events:{
            'click #toolbar > button' : 'clickOnAction',

            'click #X' : 'factSearch',
            'click #A' : 'factSearch',
            'click #B' : 'factSearch',
            'click #C' : 'factSearch',
            'click #D' : 'factSearch',
            'click #Z' : 'factSearch',

            'click #Y' : 'factSearch',

            'change #current-journal' : 'factSearch',

            'change #from' : 'factSearch',
            'change #to' : 'factSearch',
            'click-row.bs.table #table ' : 'clickAnalysisDetail',
        },
        init : function(parent){
            this._super(parent);
        },
        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.submitForm();
        },
        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },
        clickAnalysisDetail: function(e, row, $element, field){
            if (field == 'reference'){
                this.do_action({
                    name:"Factura",
                    type: 'ir.actions.act_window',
                    res_model: "account.invoice",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.invoice_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.invoice_id,
                });
            }
            if (field === 'partner'){
                this.do_action({
                    name:"Registro",
                    type: 'ir.actions.act_window',
                    res_model: "res.partner",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.partner_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.partner_id,
                });
            }
            e.stopImmediatePropagation();
        },
        submitForm: function () {
            var self = this;
            self.fetchMoveLine().then(function(moveLine) {
                return moveLine;
            }).then(function (moveLine) {
                self.moveLine = _.filter(moveLine, function(item) {
                    return item.amount_residual > 0;
                });
                return self.fetchInvoice(moveLine);
            }).then(function(accountInvoice) {
                self.accountInvoice = accountInvoice;
                return self.fetchResPartner();
            }).then(function(ResPartner){
                self.ResPartner=ResPartner;
                return self.fetchGetModelId();
            }).then(function(modelId) {
                self.modelId= modelId;
                return self.fetchReduceMoveLine();
            });
        },


        // getModelId
        fetchGetModelId: function() {
            var self = this;
            var defer = $.Deferred();
            var irModelData = new instance.web.Model('ir.model.data');
            var getObtjectReference = irModelData.get_func('get_object_reference');

            this.alive(getObtjectReference('account', 'invoice_form')).then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },

        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
            from = $( "#from" )
            .datepicker({
                dateFormat: "dd/mm/yy",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
            });
            to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
            });

            function getDate( element ) {
                var fechaSel =element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
                return date;
            }
        },
        // Move line
        fetchMoveLine: function () {
            var self = this;
            var hoy = moment().format('YYYY-MM-DD');
            var defer = $.Deferred();
            var field = ['id', 'partner_id', 'amount_residual', 'credit', 'debit', 'date_maturity', 'ref', 'invoice', 'amount_residual_currency','state'];
            var domain = [['credit', '<=', 0], ['date_maturity', '<', hoy]];
            var moveLine = new instance.web.Model('account.move.line');

            moveLine.query(field).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },
        fetchResPartner: function () {
            var self = this;
            var defer = $.Deferred();
            var ResPartner = new instance.web.Model('res.partner');
            ResPartner.query(['id','name','ruc']).filter([['active', '=', true]]).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // invoice
        fetchInvoice: function(moveline) {
            var self = this ;
            var defer = $.Deferred()
            var ref = _.map(moveline, function(map) {
                return map.invoice[0];
            });
            var fields = ['id', 'currency_id', 'number'];
            var domain = [['id', 'in', ref]];
            var accountInvoice = new instance.web.Model('account.invoice');
            accountInvoice.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },

        getAccountInvoice: function (id) {
            var self = this;
            return _.filter(self.AccountInvoice,function (item) {
                return item.invoice[0] == id;
            });
        },

        search: function () {
            var self = this;
            var results = self.ResPartner;
            results = _.map(results, function (item) {
                return {
                        label: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc),
                        value: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc)
                }
            });
            self.$('#partner').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#partner').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },

        fetchReduceMoveLine: function(){
            var self = this;
            var MoveLine = self.moveLine;
            var invoice;
            var data = [];
            _.each(MoveLine, function(item){

                invoice = self.getAccountInvoice(item.id);

                data.push({
                    id : item.id,
                    reference: item.ref,
                    number: item.number,
                    date_maturity: moment(item.date_maturity).format("DD/MM/YYYY"),
                    partner: item.partner_id[1],
                    date: item.date_maturity,
                    amount_residual: accounting.formatNumber(item.amount_residual,0,".",","),
                    partner_id: item.partner_id[0],
                    total_residual: item.amount_residual,
                    invoice_id: item.invoice[0]
                });
            });
            self.content = data;
            this.loadTable(data);
        },
        factSearch: function(){
            var self = this;
            var hoy = moment().format('YYYY-MM-DD');
            //var journal = this.$el.find('#current-journal').val();
            var desde = this.$el.find('#from').val();
            var hasta = this.$el.find('#to').val();
            var partner= this.$el.find('#partner').val().split('-');

            var content = self.content;
            if ($('#A').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.date == hoy;
                });
            }
            if ($('#B').is(":checked")){
                var date = hoy.split('-');
                var ayer = date[2] - 1;
                date.splice(2,0);
                if(date[2] < 10){
                    date[2] = '0'+ayer;
                }else{
                    date[2] = ayer;
                }
                content = _.filter(content, function (inv){
                    return inv.date == date[0]+'-'+date[1]+'-'+date[2];
                });
            }
            if ($('#C').is(":checked")){
                var date = hoy.split('-');
                content = _.filter(content, function (inv){
                    var mes = inv.date.split('-');
                    return mes[0]+'-'+mes[1] == date[0]+'-'+date[1];
                });
            }
            if ($('#D').is(":checked")){
                var date = hoy.split('-');
                var mes = date[1] - 1;
                var year;
                date.splice(1,0);
                if(date[1] == 1){
                    date[1] = '12';
                    year = date[0] - 1;
                    date[0] = year;
                }else{

                 if(date[1] < 10){
                     date[1] = '0'+mes;
                 }else{
                     date[1] = mes;
                 }
                }
                content = _.filter(content, function (inv){
                    var mes = inv.date.split('-');
                    return mes[0]+'-'+mes[1] == date[0]+'-'+date[1];
                });
            }
            if ($('#Z').is(":checked")){
                $('#datepicker').css('display','block');
                if (desde.length > 0){
                    var date= desde.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date >= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
                if (hasta.length > 0){
                    var date= hasta.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date <= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
            }else{
                $('#datepicker').css('display','none');
            }
            if (partner != ""){
                content = _.filter(content, function(inv){
                    return inv.partner_id == partner[0];
                });
            }

            self.loadTable(content)
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },
        getObjetPdf: function(rowsTable){
            var self = this;
            var rowsPdf=[];
            var rows=[];
            var rows = self.rowsData;
            var total_residual = _.reduce(_.map(rows,function(map){
                return(map.total_residual);
            }),function(memo, num){
                return memo + num;
            },0);

            if (rows.length > 0){
                rows.push({
                    reference: "Total a Cobrar",
                    partner: "",
                    date_maturity: "",
                    amount_residual: accounting.formatNumber((total_residual),0,".",","),

                });
            }

            return rows;
        },
        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var action = self.$el.find(e.target).val();
            var table = self.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            var getColumns=[];
            var rows=[];
            rowsNew = self.getObjetPdf();
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){
                    return val.field;
                });
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                // Obtener los nombre de la Cabezera
                _.each(_.map(data2,function(val){
                        return val;
                    }), function(item){
                            getColumns.push([{
                                        title: item.title,
                                        dataKey: item.field
                                    }]);
                });
                this.drawPDF(_.flatten(getColumns),rows);
            }
        },
        drawPDF: function (getColumns,rows) {
            var self = this;
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF();

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                    id : {columnWidth: '6px'},
                    reference : {columnWidth: '10px'},
                    partner : {columnWidth: '10px'},
                    date_maturity : {columnWidth: '6px'},
                    amount_residual : {halign:'right', columnWidth: '8px'}
                },
                margin: { top: 16, horizontal: 7},

                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Listado de cuentas a cobrar vencidas', data.settings.margin.left, 10);

                    if(desde.length > 0 || hasta.length > 0){
                        var fecha='';
                        if(desde){
                            fecha=fecha.concat(' Desde '+desde);
                        }
                        if (hasta){
                            fecha=fecha.concat(' Hasta '+hasta);
                        }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, data.settings.margin.left,14);
                    }
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                    }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Listado de cuentas a cobrar vencidas.pdf')
        },
    });
}
